import javax.microedition.lcdui.*;

public class ContentList extends List implements CommandListener  { 
    Cryptex  cryptex;

    ContentList(Cryptex cryptex) { 
        super(Locale.CONTENT, IMPLICIT);
        this.cryptex = cryptex;
        for (int i = 0, n = cryptex.content.size(); i < n; i++) { 
            Record rec = (Record)cryptex.content.elementAt(i);
            append(rec.key, null);
        }
        setCommandListener(this);
        addCommand(Cryptex.SELECT_CMD);
        addCommand(Cryptex.ADD_CMD);
        addCommand(Cryptex.REMOVE_CMD);
        addCommand(Cryptex.CHANGE_PASSWORD_CMD);
        addCommand(Cryptex.QUIT_CMD);
        Display.getDisplay(cryptex).setCurrent(this);        
    }
        
    public void commandAction(Command c, Displayable d) {
        if (c == Cryptex.QUIT_CMD) { 
            cryptex.quit();
        } else if (c == Cryptex.ADD_CMD) { 
            new AddDataForm(this);
        } else if (c == Cryptex.CHANGE_PASSWORD_CMD) { 
            new SetPasswordForm(cryptex, this);
        } else { 
            int i = getSelectedIndex();
            if (i >= 0) { 
                if (c == Cryptex.REMOVE_CMD) { 
                    new ConfirmDeleteForm(this, i);
                } else { 
                    new EditDataForm(this, i);
                } 
            }
        }
    }
}
            
