public class Record { 
    String key;
    String value;
    int    rid;

    byte[] pack() {
        int keyLen = key.length();
        int valueLen =  value.length();
        byte[] record = new byte[(keyLen + valueLen + 1)*2];
        int j = 0;
        for (int i = 0; i < keyLen; i += 1, j += 2) { 
            char ch = key.charAt(i);
            record[j] = (byte)(ch >> 8);
            record[j+1] = (byte)ch;
        }
        j += 2;
        for (int i = 0; i < valueLen; i += 1, j += 2) { 
            char ch = value.charAt(i);
            record[j] = (byte)(ch >> 8);
            record[j+1] = (byte)ch;
        }
        return record;
    }

    void unpack(byte[] record) {
        char[] chars = new char[record.length/2];        
        int keyLen = -1;
        for (int i = 0; i < chars.length; i++) {
            if ((chars[i] = (char)((record[i*2] << 8) | (record[i*2+1] & 0xFF))) == 0) { 
                keyLen = i;
            }
        }
        if (keyLen < 0) { 
            key = "***";
            value = "???";
        } else {
            key = new String(chars, 0, keyLen);
            value = new String(chars, keyLen+1, chars.length-keyLen-1);
        }
    }

    Record(int rid, byte[] record) { 
        this.rid = rid;
        unpack(record);
    }

    Record(String key, String value) { 
        this.key = key;
        this.value = value;
    }
}

    
        
        
            
        