import javax.microedition.lcdui.*;

public class SetPasswordForm extends Form implements CommandListener  { 
    Cryptex  cryptex;
    Displayable parent;
    TextField question;
    TextField answer;
    TextField confirm;

    static final int MAX_QUESTION_LENGTH = 256;
    static final int MAX_ANSWER_LENGTH = 256;

    SetPasswordForm(Cryptex cryptex, Displayable parent) { 
        super(Locale.SET_PASSWORD);
        this.cryptex = cryptex;
        this.parent = parent;
        question = new TextField(Locale.QUESTION, null, MAX_QUESTION_LENGTH, TextField.ANY);
        answer = new TextField(Locale.ANSWER, null, MAX_ANSWER_LENGTH, TextField.ANY);
        confirm = new TextField(Locale.CONFIRM, null, MAX_ANSWER_LENGTH, TextField.ANY);
        append(question);
        append(answer);
        append(confirm);
        setCommandListener(this);
        addCommand(Cryptex.ENTER_CMD);
        addCommand(parent == null ? Cryptex.QUIT_CMD : Cryptex.BACK_CMD);
        Display.getDisplay(cryptex).setCurrent(this);        
    }

    public void commandAction(Command c, Displayable d) {
        if (c == Cryptex.QUIT_CMD) { 
            cryptex.quit();
        } else if (c == Cryptex.BACK_CMD) {
            Display.getDisplay(cryptex).setCurrent(parent);        
        } else if (c == Cryptex.ENTER_CMD) { 
            String password = answer.getString();
            String passwordQuestion = question.getString();
            String confirmPassword = confirm.getString();
            if (password.length() == 0) { 
                cryptex.error(Locale.EMPTY_PASSWORD);
                return;
            }            
            if (!password.equals(confirmPassword)) { 
                cryptex.error(Locale.DONT_MATCH);
                return;
            }
            if (passwordQuestion.endsWith("?")) { 
                passwordQuestion = passwordQuestion.substring(0, passwordQuestion.length()-1);
            }
            if (parent == null) { 
                cryptex.setPassword(passwordQuestion, password);
                new ContentList(cryptex);
            } else { 
                cryptex.changePassword(passwordQuestion, password);
                Display.getDisplay(cryptex).setCurrent(parent);        
            }
        }
    }
}    
